﻿// Copyright (c) Microsoft Open Technologies, Inc. All rights reserved.
// Licensed under the Apache License, Version 2.0. See License.txt in the project root for license information.

namespace Microsoft.Data.Entity.FunctionalTests.TestModels.Northwind
{
    public class OrderDetail
    {
        public int OrderID { get; set; }
        public int ProductID { get; set; }
        public decimal UnitPrice { get; set; }
        public short Quantity { get; set; }
        public float Discount { get; set; }

        public virtual Product Product { get; set; }
        public virtual Order Order { get; set; }

        protected bool Equals(OrderDetail other)
        {
            return OrderID == other.OrderID
                   && ProductID == other.ProductID;
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj))
            {
                return false;
            }

            if (ReferenceEquals(this, obj))
            {
                return true;
            }

            return obj.GetType() == GetType()
                   && Equals((OrderDetail)obj);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                return (OrderID * 397) ^ ProductID;
            }
        }
    }
}
